#!/usr/bin/python
#!/opt/local/Library/Frameworks/Python.framework/Versions/2.7/Resources/Python.app/Contents/MacOS/Python
#!/opt/local/Library/Frameworks/Python.framework/Versions/2.6/Resources/Python.app/Contents/MacOS/Python
#!/opt/local/bin/python

import os
import sys
import string
import tarfile
import time
import subprocess
import re
import tempfile

from mercurial import hg, commands, ui, cmdutil, dispatch
from mercurial import merge as mergemod


def main(argv):
	f = None
	f = open('/dev/null', 'a');
	
	if os.environ.has_key('HGGIT_LOGFILEPATH'):
		logfilepath = os.environ['HGGIT_LOGFILEPATH']
		f = open(logfilepath, 'a')
	
	# f = open('/Users/user/Desktop/git.txt', 'a')
	f.write('\n ********* command: git ' + ' '.join(sys.argv[1:]) + ' *********\n')
	# f.write('\t pwd: ' + os.getcwd())
	# f.write('\n')
	# for param in os.environ.keys():
	#	f.write("%20s %s\n" % (param,os.environ[param]))

	repodir = os.getcwd()
	myui = ui.ui()
	
	# We capture the whole hg output. This makes it easier to compare with git's.
	myui.pushbuffer()
	
	# Some commands have a PWD set to / and pass the repository dir as an argument
	if argv[0] == "ls-remote":
		repodir = argv[2]
	# f.write('\t repodir: %s\n' % repodir)
	
	force_mercurial = False
	xcode_invoked = False
	
	if os.environ.has_key('HGGIT_MODE'):
		xcode_invoked = (os.environ['HGGIT_MODE'] == 'XCODEPLUGIN')

	if argv[0] == "clone" and not argv[3].startswith("git://"):
		force_mercurial = True
	
	if argv[0] == "init":
		force_mercurial = True

	if not force_mercurial:
		if not os.path.exists(os.path.join(repodir, ".hg")):
			f.write('.hg does not exist, reverting to git\n')
			
			if os.environ.has_key('HGGIT_ORIGGITPATH'):
				gitorig = os.environ['HGGIT_ORIGGITPATH']
			elif not xcode_invoked:
				gitorig = sys.argv[0] + ".orig"
			else:
				gitorig = '/usr/bin/git' # shouldn't be used, it's a fallback
			#gitorig = sys.argv[1]
			
			# Using this temporary file to capture actual, byte-accurate git output.
			# Can be of great help to analyse and reproduce with hg.
			tmpf = tempfile.TemporaryFile()
			ret = subprocess.call([gitorig] + sys.argv[1:], stdout=tmpf)#sys.stdout)
			#f.write('command: git %s \n' % ' '.join(sys.argv[1:]))
			f.write('git result:\n')
			f.write('>>>>>>>\n')
			tmpf.seek(0)
			f.write(tmpf.read())
			f.write('\n<<<<<<<\n')
			tmpf.seek(0)
			sys.stdout.write(tmpf.read())
			exit(ret)
		else:
			f.write('.hg exists, proceeding with Mercurial\n')
	
	if argv[0] == "status":
		cmd, func, args, options, cmdoptions = dispatch._parse(myui, ["status"])
		repo = hg.repository(myui, path = ".")
		myui.pushbuffer()
		commands.status(myui,repo,*args,**cmdoptions)
		output_status = myui.popbuffer()
		
		cmd, func, args, options, cmdoptions = dispatch._parse(myui, ["resolve","-l"])
		myui.pushbuffer()
		commands.resolve(myui,repo,*args,**cmdoptions)
		output_resolves = myui.popbuffer()
		
		status = output_status.split("\n")
		resolves = output_resolves.split("\n")
		
		for rl in resolves:
			if rl.startswith("U "):
				modified = string.replace(rl ,"U ", "M ",1)
				if modified in status:
					status.remove(modified)
					myui.write(rl + "\n")
		
		for st in status:
			myui.write(st+"\n")
	
	elif argv[0] == "init":
		commands.init(myui)
		if not xcode_invoked:
			os.mkdir(".git")
			os.mkdir(".git/info")

	elif argv[0] == "clone":
		cmd, func, args, options, cmdoptions = dispatch._parse(myui, ["clone","-q",argv[3],argv[4]])
		commands.clone(myui,args[0],args[1],**cmdoptions)
		if not xcode_invoked:
			os.mkdir(args[1]+"/.git")
			
	elif argv[0] == "add":
		cmd, func, args, options, cmdoptions = dispatch._parse(myui, ["resolve","-l"])
		repo = hg.repository(myui, path = ".")
		myui.pushbuffer()
		commands.resolve(myui,repo,*args,**cmdoptions)
		output_resolves = myui.popbuffer()

		resolves = output_resolves.split("\n")
		file = argv[argv.index("--")+1]
		item = "U " + string.replace(file, repo.root + "/","")
		myui.write(item+"\n")
		myui.write(resolves)
		if item in resolves:
			cmd, func, args, options, cmdoptions = dispatch._parse(myui, ["resolve","-m",file])
			myui.pushbuffer()
			commands.resolve(myui,repo,*args,**cmdoptions)
			myui.popbuffer()

		else:
			cmd, func, args, options, cmdoptions = dispatch._parse(myui, argv)
			myui.pushbuffer()
			commands.add(myui,repo,*args,**cmdoptions)
			myui.popbuffer()
	elif argv[0] == "mv":
		cmd, func, args, options, cmdoptions = dispatch._parse(myui, ["rename", argv[1], argv[2]])
		repo = hg.repository(myui, path = ".")
		myui.pushbuffer()
		commands.rename(myui,repo,*args,**cmdoptions)
		myui.popbuffer()
	elif argv[0] == "rm":
		if argv[1] == "-f" and argv[2] == "-r"  and argv[3] == "--":
			arguments = ["remove"]
			arguments.extend(argv[4:])
			cmd, func, args, options, cmdoptions = dispatch._parse(myui,arguments)
			repo = hg.repository(myui, path = ".")
			myui.pushbuffer()
			commands.remove(myui, repo, *args, **cmdoptions)
			myui.popbuffer()
	elif argv[0] == "commit":
		cmd, func, args, options, cmdoptions = dispatch._parse(myui, argv)
		repo = hg.repository(myui, path = ".")
		myui.pushbuffer()
		commands.commit(myui, repo, *args, **cmdoptions)
		output_commit = myui.popbuffer()
				
		#ms = mergemod.mergestate(repo)
		#myui.write(ms)
		
		#if len(output_commit) == 0:
		#	cmd, func, args, options, cmdoptions = dispatch._parse(myui, ["tip"])
		#	myui.pushbuffer()
		#	commands.tip(myui, repo, **cmdoptions)
		#	output_tip = myui.popbuffer()
		#	tips = output_tip.split("\n")
		#	if tips[0].startswith("changeset:   0:"):

	elif argv[0] == "branch":
		if len(argv) == 1:
			repo = hg.repository(myui, path = ".")
			currentbranch = repo.dirstate.branch()
			myui.write("* " + currentbranch)
			myui.write("\n")
			
			for tag, node in repo.branchtags().items():
				if tag != currentbranch:
					myui.write(tag)
					myui.write("\n")
		elif len(argv) == 3:
			cmd, func, args, options, cmdoptions = dispatch._parse(myui, ["branch",argv[1]])
			repo = hg.repository(myui, path = ".")
			commands.branch(myui, repo, *args, **cmdoptions)

	elif argv[0] == "log":
		cmdline = " ".join(argv)
		f.write("log command###: %s\n" % cmdline )
		result = re.match('log --abbrev=(?P<abbrev>[-+]?\d+)\s(?:(?P<since>[-]\d+)\s)?(?:(?P<until>[-]\d+|HEAD|master|default|[0-9a-f]+)\s)?(?:(?P<since2>[-]\d+)\s)?(?:(?P<namestatus>--name-status)\s)?(?:--pretty=format:(?P<format>\S+))?.*',cmdline)
		if result != None:
			# f.write("HG matches: abbrev=%s, since=%s, until=%s, since2=%s, namestatus=%s, format=%s\n" % (result.group('abbrev'), result.group('since'), result.group('until'), result.group('since2'), result.group('namestatus'), result.group('format')))
			namestatus=(result.group('namestatus') != None)
			since=result.group('since')
			until=result.group('until')

			hgtemplate = "\\x00{node|short}\\n{author|person}\\n{author|email}\\n{date|hgdate}\\n{desc}\\n\\x01\\n"

			if namestatus:
				hgtemplate += "{file_adds % 'A\t{file}\n'}{file_dels % 'D\t{file}\n'}{file_mods % 'M\t{file}\n'}\\n";

			# --template "{node|short}\\n{author|person}\\n{author|email}\\n{date|hgdate}\\n{desc}\\n{file_adds % 'A\t{file}\n'}{file_dels % 'D\t{file}\n'}{file_mods % 'M\t{file}\n'}\\n\n"

	 		includeargs=[]
			filearg=None
			if "--" in argv:
				files=argv[argv.index("--")+1:]
				includeargs = []
				for filepath in files:
					includeargs += ["--include", filepath]

			arguments = ["log"] + includeargs + ["--template",hgtemplate]
			
			#f.write("HG args1: %s\n" % " ".join(arguments) )
			if since != None:
				limit = -int(since)
				arguments.append("--limit")
				arguments.append(str(limit))
					
			if until != None and until != "HEAD":
				if namestatus:
					revision=until
				else:
					revision = until+ ":0"
				arguments.append("-r")
				arguments.append(revision)
			

			# f.write("HG args: %s\n" % " ".join(arguments) )
			cmd, func, args, options, cmdoptions = dispatch._parse(myui,arguments)
			repo = hg.repository(myui, path = repodir)
			myui.pushbuffer()
			commands.log(myui, repo, *args, **cmdoptions)
			output = myui.popbuffer()

			# removing extra date tags that are outputed by hg seems no longer necessary
			#output = string.replace(output, " -7200", "")
			# f.write("hgout: %s" % output)
			myui.write(output)

	elif argv[0] == "archive":
		# so that archive do not overwrite current files if no prefix is given
		archivedir = tempfile.mkdtemp()
		argi=1
		prefix=""
		if argv[argi].startswith("--prefix"):
			prefix = argv[argi].split("=")[1]
			argi+=1
		
		revision = argv[argi]
		argi+=1
		path = ""
		
		if revision.find(":") >= 0:
			revision_path = revision.split(":")
			revision = revision_path[0]
			path = revision_path[1] + "/"
		
		filename = argv[argi]
		file = path + filename
		
		archivefilename = os.path.join(archivedir, prefix+filename)
		archivetarfilename = archivefilename + ".tar"
		arguments = ["cat", "--output",archivefilename]
		if revision != "HEAD":
			arguments.append("-r")
			arguments.append(revision)
		
		cmd, func, args, options, cmdoptions = dispatch._parse(myui, arguments)
		repo = hg.repository(myui, path = ".")
		commands.cat(myui, repo,file, *args, **cmdoptions)
		tar = tarfile.open(archivetarfilename, "w")
		tar.add(archivefilename, arcname=prefix+filename)
		tar.close()
		
		ff = open(archivetarfilename,"r")
		output = ff.read()
		ff.close()
		myui.write(output)
		# f.write(output)
		# os.remove(prefix+filename)
		# os.remove(prefix+filename+".tar")
		os.remove(archivefilename)
		os.remove(archivetarfilename)
		os.rmdir(archivedir)

	elif argv[0] == "checkout":
		if argv[1] == "-f" and argv[2] == "--":
			arguments = ["revert"]
			arguments.extend(argv[3:])
			cmd, func, args, options, cmdoptions = dispatch._parse(myui,arguments)
			repo = hg.repository(myui, path = ".")
			commands.revert(myui, repo, *args, **cmdoptions)
		elif len(argv) == 3 and argv[2] == "--merge":
			cmd, func, args, options, cmdoptions = dispatch._parse(myui,["update",argv[1]])
			repo = hg.repository(myui, path = ".")
			commands.update(myui, repo, *args, **cmdoptions)

	elif argv[0] == "blame":
		include = argv[argv.index("--")+1]
		cmd, func, args, options, cmdoptions = dispatch._parse(myui,["annotate","-udqcl",include])
		repo = hg.repository(myui, path = ".")
		myui.pushbuffer()
		myui.quiet=True
		commands.annotate(myui, repo, *args, **cmdoptions)
		lignes = myui.popbuffer().split("\n")
		while lignes.count("") > 0:
			lignes.remove("")
		
		cmd, func, args, options, cmdoptions = dispatch._parse(myui,["diff","-U","0",include])
		repo = hg.repository(myui, path = ".")
		myui.pushbuffer()
		myui.quiet=True
		commands.diff(myui, repo, *args, **cmdoptions)
		difflines = myui.popbuffer().split("\n")

		# RS: because Mercurial only annotates the latest committed revision,
		# we need to insert 000000 revs for working copy edited/added lines, and remove the removed ones
		# like git does
		ops = []
		for line in difflines:
			result = re.match("^@@ -(\\d+),(\\d+) \\+(\\d+),(\\d+) @@$", line)	
			if result != None:
				ops.append({'at':int(result.group(1)), 'delete':int(result.group(2)), 'insert':int(result.group(4))})
				# f.write("range: %s %s %s %s\n" % (result.group(1), result.group(2), result.group(3), result.group(4)))
		
		# It's important to propagate changes from end of file towards begining.
		ops.reverse()

		# Inserting None for uncommitted changes
		for op in ops:
			at = op['at']
			deln = op['delete']
			insn = op['insert']
			if deln > 0:
				delend = at+deln
				# f.write("del: %s %s\n" % (at, delend))		
				del lignes[at:delend]
			for i in xrange(insn):
				lignes.insert(at, None)

		# f.write("\n".join(difflines))

		lindex=0
		for ligne in lignes:
			# Generate '0' revision for uncommitted changes, like git.
			if ligne == None:
				myui.write( "000000000000" +"\t"+"(Not Committed Yet\t"+"2013-11-11 15:24:26 02:06:47 +0200"+"\t"+str(lindex+1)+")"+"no source"+"\n")
			else:
				# f.write("ligne: %s\n" % ligne)
				result = re.split('\ *(\w+)\ (\w+)\ (\d\d\d\d\-\d\d\-\d\d)\:\ *(\d*)\:\ (.*)',ligne)
				# f.write("result: %s" % "|".join(result))
				while result.count("") > 0:
					result.remove("")
				
				source = ''
				if len(result) == 5:
					source = result[4]
				# RS: line number in Mercurial is index in the revision of first appearance
				# In git, it's the line number in current file.
				myui.write( result[1]+"\t"+"("+result[0]+"\t"+result[2]+" 02:06:47 +0200"+"\t"+str(lindex+1)+")"+source+"\n")

			lindex += 1
		
	elif argv[0] == "remote":
		#repo = hg.repository(myui, path = ".")
		#commands.paths(myui, repo)
		myui.write("default\x09http://xxxxx (fetch)\n")
		myui.write("default\x09http://xxxxx (push)\n")

	elif argv[0] == "ls-remote":
		#myui.write("c654bd3a21693018927534d53d218ab4e13a61b4	refs/heads/default\n")
		cmd, func, args, options, cmdoptions = dispatch._parse(myui,["heads","--template", "{node}\\trefs/heads/{branch}\\n"])
		repo = hg.repository(myui, path = repodir)
		commands.heads(myui, repo, *args, **cmdoptions)

	elif argv[0] == "config" and argv[1] == "--get":
		if argv[2] == "branch.default.remote":
			myui.write("default\n")
		elif argv[2] == "branch.default.merge":
			myui.write("refs/heads/default\n")
		elif argv[2] == "remote.origin.url":
			myui.write("default\n")
			# should be like below. Would that hold with hg URLs? Note sure.
			# myui.write("git@github.com:user/project.git\n")

	res = myui.popbuffer();
	f.write("hg result: \n>>>>>>>\n%s\n<<<<<<\n" % res)
	sys.stdout.write(res)

	if f != None:
		f.close()

if __name__ == "__main__":
    main(sys.argv[1:])
